require 'sketchup.rb'

class Unhide_all
  def Unhide_all::start
    model=Sketchup.active_model
    model.start_operation "Unhide all entities"
    sel = Sketchup.active_model.selection
    sel = Sketchup.active_model.entities if sel.empty? 
    Unhide_all.unhide(sel)
    model.commit_operation
  end
  
  def Unhide_all::unhide(ent)
    ent.each do |e|
      case e
      when Sketchup::Group
        e.make_unique
        Unhide_all.unhide(e.entities)
      when Sketchup::ComponentInstance
        Unhide_all.unhide(e.definition.entities) 
      end
    e.hidden = false if e.hidden?
    end
  end
  
end

if( not file_loaded?("unhide_all.rb") )
  UI.menu("Plugins").add_item("Unhide elements") { Unhide_all.start }
end

file_loaded "unhide_all.rb"

